<?php
namespace Teknisa\COZ\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class Coz10600 extends \Zeedhi\Framework\Controller\Report {

    protected $requisicaoPlanejamentoProducaoService;
    protected $distribuicaoProducaoController;
    protected $coz10600Service;
    protected $listaController;
    protected $entityManager;
    protected $reportName;
    protected $nrlistaetiq;
    protected $birtStrategy;
    protected $nrlistaFilialSetor;
    protected $novoCodigo;

    public function __construct(ReportService $reportService, $entityManager, $requisicaoPlanejamentoProducaoService, $distribuicaoProducaoController, $coz10600Service, $listaController, $birtStrategy, $novoCodigo) {
        $this->requisicaoPlanejamentoProducaoService = $requisicaoPlanejamentoProducaoService;
        $this->distribuicaoProducaoController = $distribuicaoProducaoController;
        $this->coz10600Service = $coz10600Service;
        $this->listaController = $listaController;
        $this->entityManager = $entityManager;
        $this->birtStrategy  = $birtStrategy;
        $this->novoCodigo = $novoCodigo;
        
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
    'dis10600' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NRORG' => 'P_NRORG',
                'CDCENTRAL' => 'P_CDCENTRAL',
                'NRLISTASERV' => 'P_NRLISTASERV',
                'LISTAPRODUTO' => 'P_LISTAPROD',
                'DTINICIAL' => 'P_DTCONSUMOINI',
                'DTFINAL' => 'P_DTCONSUMOFIN',
                'NRDISTPROD' => 'P_NRDISTPROD',
                'CDPICTPROD'=> 'P_CDPICTPROD'
            )
        ),
    'dis10601' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NRORG' => 'P_NRORG',
                'CDCENTRAL' => 'P_CDCENTRAL',
                'NRLISTASERV' => 'P_NRLISTASERV',
                'LISTAPRODUTO' => 'P_LISTAPROD',
                'DTINICIAL' => 'P_DTCONSUMOINI',
                'DTFINAL' => 'P_DTCONSUMOFIN',
                'NRDISTPROD' => 'P_NRDISTPROD',
                'CDPICTPROD'=> 'P_CDPICTPROD'
            )
        ),
    'dis10602' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NRLISTASERV' => 'P_NRLISTASERV',
                'NRLISTAETIQ' => 'P_NRLISTAETIQ',
                'CDCENTRAL' => 'P_CDCENTRAL',
                'LISTAPRODUTO' => 'P_LISTAPROD',
                'DTINICIAL' => 'P_DTCONSUMOINI',
                'DTFINAL' => 'P_DTCONSUMOFIN',
                'NRDISTPROD' => 'P_NRDISTPROD',
                'NRORG' => 'P_NRORG'
            )
        ),
    'dis10603' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'NRORG' => 'P_NRORG',
                'CDCENTRAL' => 'P_CDCENTRAL',
                'NRLISTASERV' => 'P_NRLISTASERV',
                'LISTAPRODUTO' => 'P_LISTAPROD',
                'DTINICIAL' => 'P_DTCONSUMOINI',
                'DTFINAL' => 'P_DTCONSUMOFIN',
                'NRDISTPROD' => 'P_NRDISTPROD',
                'CDPICTPROD'=> 'P_CDPICTPROD'
            )
        ),
    'dis10604' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'NRORG' => 'P_NRORG',
                'CDCENTRAL' => 'P_CDCENTRAL',
                'NRLISTASERV' => 'P_NRLISTASERV',
                'LISTAPRODUTO' => 'P_LISTAPROD',
                'DTINICIAL' => 'P_DTCONSUMOINI',
                'DTFINAL' => 'P_DTCONSUMOFIN',
                'NRDISTPROD' => 'P_NRDISTPROD',
                'CDPICTPROD'=> 'P_CDPICTPROD'
            )
        ),
    'dis15504' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NRORG' => 'P_NRORG',
                'DTINICIAL' => 'P_DTINI',
                'DTFINAL' => 'P_DTFIN',
                'LISTAPRODUTO' => 'P_LISTAPROD',
                'NRDISTPROD' => 'P_NRDISTPROD',
                'NRLISTASERV' => 'P_NRLISTASERV',
                'CDCENTRAL' => 'P_CDCENTRAL'
            )
        ),
    'dis10605' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
                array (
                    'NRLISTASERV' => 'P_NRLISTASERV',
                    'NRLISTAETIQ' => 'P_NRLISTAETIQ',
                    'CDCENTRAL' => 'P_CDCENTRAL',
                    'LISTAPRODUTO' => 'P_LISTAPROD',
                    'DTINICIAL' => 'P_DTCONSUMOINI',
                    'DTFINAL' => 'P_DTCONSUMOFIN',
                    'NRDISTPROD' => 'P_NRDISTPROD',
                    'NRORG' => 'P_NRORG'
                )
        ),
    'dis10606' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
                array (
                    'NRLISTASERV' => 'P_NRLISTASERV',
                    'NRLISTAETIQ' => 'P_NRLISTAETIQ',
                    'CDCENTRAL' => 'P_CDCENTRAL',
                    'LISTAPRODUTO' => 'P_LISTAPROD',
                    'DTINICIAL' => 'P_DTCONSUMOINI',
                    'DTFINAL' => 'P_DTCONSUMOFIN',
                    'NRDISTPROD' => 'P_NRDISTPROD',
                    'NRORG' => 'P_NRORG'
                )
        ),
    'dis10607' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
                array (
                    'DTINICIAL' => 'P_DTCONSUMOINI',
                    'DTFINAL' => 'P_DTCONSUMOFIN',
                    'NRORG' => 'P_NRORG',
                    'CDCENTRAL' => 'P_CDCENTRAL',
                    'NRDISTPROD' => 'P_NRDISTPROD',
                    'NRLISTASERV' => 'P_NRLISTASERV',
                    'LISTAPRODUTO' => 'P_LISTAPROD'
                )
        ),
    'dis10608' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
                array (
                    'DTINICIAL'    => 'P_DTINI',
                    'DTFINAL'      => 'P_DTFIN',
                    'NRORG'        => 'P_NRORG',
                    'CDCENTRAL'    => 'P_CDCENTRAL',
                    'NMCENTRAL'    => 'P_NMCENTRAL',
                    'NRDISTPROD'   => 'P_NRDISTPROD',
                    'NRLISTASERV'  => 'P_NRLISTASERV',
                    'LISTAPRODUTO' => 'P_LISTAPROD',
                    'CDPICTPROD'   => 'P_CDPICTPROD',
                    'CDSETOR'      => 'P_CDSETOR'
                )
        ),
    'dis10609' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NRORG' => 'P_NRORG',
                'CDCENTRAL' => 'P_CDCENTRAL',
                'DTINICIAL' => 'P_DTCONSUMOINI',
                'NRLISTASERV' => 'P_NRLISTASERV',
                'DTFINAL' => 'P_DTCONSUMOFIN',
                'NRDISTPROD' => 'P_NRDISTPROD',
                'LISTAPRODUTO' => 'P_LISTAPROD'
                // 'CDPICTPROD'=> 'P_CDPICTPROD'
            )
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        
        $row['CDSETOR'] = $this->montaListaFilialSetor($row['NRORG'], $row['LISTASETOR']);

        $listaFilial = $row["LISTAFILIAL"] = $this->coz10600Service->retornaFiliais((array)$row);
        $row["LISTAGRUPSERV"] = $this->coz10600Service->retornaGrupServ((array)$row);
        $row['SERVICOFILIAL'] = $this->coz10600Service->retornaServico((array)$row);
        $listaServico = $row["LISTASERVICO"] = $this->coz10600Service->concatArray($row['SERVICOFILIAL'], 'SERVICO');
        $row["LISTAPRODUTO"] = $this->coz10600Service->retornaProduto((array)$row);
        $this->reportName = $row['CD_REPORT_NAME'];
        $this->nrorg = $row['NRORG'] = $this->coz10600Service->environment->getNrorgTrab();
        $cdcentral = $row['CDCENTRAL'];
        $dtinicial = $row['DTINICIAL'];
        $dtfinal = $row['DTFINAL'];
        $listaproduto = $row['LISTAPRODUTO'];
        $row['NRLISTASERV'] =  $this->listaController->geraListaServico($row['LISTASERVICO'], $row['NRORG']);

        if($this->reportName == 'dis10602' or $this->reportName == 'dis10605' or $this->reportName == 'dis10606') {

            $lista = $this->distribuicaoProducaoController->retornaListaEtiquetas($cdcentral, $dtinicial, $dtfinal, $row['NRLISTASERV'] , $listaproduto);
            if ($lista) {
                $this->nrlistaetiq
                    = $this->requisicaoPlanejamentoProducaoService->geraLista(
                    $this->nrorg, $lista, '-'
                );
            } else {
                $this->nrlistaetiq = 'X';
            }

            $row['NRLISTAETIQ'] = $this->nrlistaetiq;

            if ($this->reportName == 'dis10605') {
                $row["LISTASERVICO"] = $listaServico ? $listaServico : 'T';
                $row["LISTAFILIAL"] = $listaFilial ? $listaFilial : 'T';
            }
        }
    }
    
    public function montaListaFilialSetor($nrorg, $listaSetor){
        $filiaisSetor = rtrim($listaSetor, '_');
        $arrayFiliaisSetor = explode('_', $filiaisSetor);
        if ($arrayFiliaisSetor[0]) {
            $this->nrlistaFilialSetor = $this->novoCodigo->getCodeByTableName(
                "LISTA", $nrorg
            );
            foreach ($arrayFiliaisSetor as $setor) {
                $FilialSetorParametros = array(
                    "NRORG" => $nrorg, "NRLISTA" => $this->nrlistaFilialSetor,
                    "CDLISTA" => $setor
                , "DTULTATULIST" => '', "NRORGINCLUSAO" => '',
                    "DTINCLUSAO" => ''
                , "CDOPERINCLUSAO" => '', "IDATIVO" => '', "CDOPERULTATU" => ''
                , "DTULTATU" => '', "NRORGULTATU" => '', "DTULTATUPRFIL" => ''
                , "__is_new" => true
                );
                $this->saveLista($FilialSetorParametros);
            }
        } else {
            $this->nrlistaFilialSetor = 0;
        }
        return $this->nrlistaFilialSetor;
    }
    
    public function saveLista($param){
        $request = new DTO\Request\Row($param, "save", "/dummy", " ");
        $response = new DTO\Response();
        $this->listaController->save($request, $response);
    }
    
    public function relCustomizavelDistProd(DTO\Request\Row $request, DTO\Response $response) {
	    $row = $request->getRow();
	    $listaFilial = $row["LISTAFILIAL"] = $this->coz10600Service->retornaFiliais((array)$row);
	    $row["LISTAGRUPSERV"] = $this->coz10600Service->retornaGrupServ((array)$row);
	    $row['SERVICOFILIAL'] = $this->coz10600Service->retornaServico((array)$row);
	    $listaServico = $row["LISTASERVICO"] = $this->coz10600Service->concatArray($row['SERVICOFILIAL'], 'SERVICO');
        $row["LISTAPRODUTO"] = $this->coz10600Service->retornaProduto((array)$row);
        $row['NRLISTASERV'] =  $this->listaController->geraListaServico($row['LISTASERVICO'], $row['NRORG']);
	    
	    $sql = "SELECT
                    DISTRIBUICAO.CDCENTRAL,
                    FC.NMFILIAL AS NMCENTRAL,
                    DISTRIBUICAO.NRDISTPROD AS DISTRIBUICAO,
                    DSDISTRIBREFEICAO AS DESCRICAO,
                    PT.CDARVPROD AS CODPRODUTO,
                    DISTRIBUICAO.CDPRODUTO,
                    PT.NMPRODUTO AS PRODUTO,
                    PT.SGUNIDADE AS UN,
                    DISTRIBUICAO.CDFILIAL AS CODFILIAL,
                    F.NMFILIAL AS AGREGADA,
                    DISTRIBUICAO.CDSERVFILI AS CODSERVICO,
                    S.NMSERVICO AS SERVICO,
                    TO_CHAR(DISTRIBUICAO.DTCARDAPIO, 'DD/MM/YYYY') AS DATACONSUMO,
                    DISTRIBUICAO.QT,
                    DISTRIBUICAO.CDCLIENTE,
                    CL.NMRAZSOCCLIE AS RAZAOSOCIAL,
                    DISTRIBUICAO.CDDESTFILI,
                    DT.NMDESTFILI AS DESTINO
                FROM
                    (
                        SELECT
                            D.NRDISTPROD,
                            D.DSDISTRIBREFEICAO,
                            CDC.CDPRODPRODUCAO   AS CDPRODUTO,
                            C.CDFILIAL,
                            C.CDSERVFILI,
                            D.CDCENTRAL,
                            CD.DTCARDAPIO,
                            :P_DTCONSUMOINI AS P_DTCONSUMOINI,
                            :P_DTCONSUMOFIN AS P_DTCONSUMOFIN,
                            DC.CDCLIENTE,
                            DC.CDDESTFILI,
                            C.NRORG,
                            CDC.QTTOTPRATO       AS QT
                        FROM
                            (
                                SELECT
                                    CDFILIAL,
                                    CDSERVFILI,
                                    NRORG
                                FROM
                                    LISTA_SERVICO
                                WHERE
                                    NRLISTA = :P_NRLISTASERV
                                    AND NRORG = :P_NRORG
                            ) L_FILISERV, DISTPROD                                                                                         D
                            INNER JOIN CARDDISTPROD                                                                                     C ON C.NRDISTPROD = D.NRDISTPROD
                                                         AND C.NRORG = D.NRORG
                            INNER JOIN DISTCARD                                                                                         DC ON DC.NRDISTCARD = C.NRDISTCARD
                                                      AND DC.NRORG = C.NRORG
                            INNER JOIN CARDADIA                                                                                         CD ON CD.CDFILIAL = C.CDFILIAL
                                                      AND CD.NRCARDAPIO = C.NRCARDAPIO
                                                          AND CD.NRORG = C.NRORG
                            INNER JOIN CNFDISTCARD                                                                                      CDC ON CDC.NRDISTCARD = C.NRDISTCARD
                                                          AND CDC.NRORG = C.NRORG
                        WHERE
                            D.NRORG = :P_NRORG
                            AND D.CDCENTRAL = :P_CDCENTRAL
                                AND ( D.NRDISTPROD = :P_NRDISTPROD
                                      OR :P_NRDISTPROD IS NULL )
                                    AND ( L_FILISERV.CDFILIAL = C.CDFILIAL )
                                        AND ( L_FILISERV.CDSERVFILI = C.CDSERVFILI )
                                            AND ( TRUNC(CD.DTCARDAPIO) BETWEEN :P_DTCONSUMOINI AND :P_DTCONSUMOFIN )
                                                AND ( ( :P_LISTAPROD = 'T' )
                                                      OR ( INSTR(:P_LISTAPROD, CDC.CDPRODPRODUCAO) > 0 ) )
                        UNION ALL
                        SELECT
                            D.NRDISTPROD,
                            D.DSDISTRIBREFEICAO,
                            P.CDPRODUTO,
                            P.CDFILIAL,
                            P.CDSERVFILI,
                            D.CDCENTRAL,
                            P.DTCARDAPIO,
                            :P_DTCONSUMOINI AS P_DTCONSUMOINI,
                            :P_DTCONSUMOFIN AS P_DTCONSUMOFIN,
                            P.CDCLIENTE,
                            P.CDDESTFILI,
                            D.NRORG,
                            P.QTTOTPRODUTO AS QT
                        FROM
                            DISTPROD        D
                            INNER JOIN PRODDISTPROD    P ON P.NRDISTPROD = D.NRDISTPROD
                                                         AND P.NRORG = D.NRORG
                            INNER JOIN LISTA_SERVICO   L_FILISERV ON L_FILISERV.NRLISTA = :P_NRLISTASERV
                                                                   AND L_FILISERV.CDFILIAL = P.CDFILIAL
                                                                       AND L_FILISERV.CDSERVFILI = P.CDSERVFILI
                                                                           AND L_FILISERV.NRORG = P.NRORG
                        WHERE
                            D.NRORG = :P_NRORG
                            AND D.CDCENTRAL = :P_CDCENTRAL
                                AND ( D.NRDISTPROD = :P_NRDISTPROD
                                      OR :P_NRDISTPROD IS NULL )
                                    AND ( TRUNC(P.DTCARDAPIO) BETWEEN :P_DTCONSUMOINI AND :P_DTCONSUMOFIN )
                                        AND ( ( :P_LISTAPROD = 'T' )
                                              OR ( INSTR(:P_LISTAPROD, P.CDPRODUTO) > 0 ) )
                    ) DISTRIBUICAO
                    LEFT JOIN CLIENTE                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             CL ON CL.CDCLIENTE = DISTRIBUICAO.CDCLIENTE
                                            AND CL.NRORG = DISTRIBUICAO.NRORG
                    LEFT JOIN DESTFILI                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            DT ON DT.CDDESTFILI = DISTRIBUICAO.CDDESTFILI
                                             AND DT.CDFILIAL = DISTRIBUICAO.CDFILIAL
                                                 AND DT.NRORG = DISTRIBUICAO.NRORG
                    INNER JOIN PRODUTO                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             PT ON PT.CDPRODUTO = DISTRIBUICAO.CDPRODUTO
                                             AND PT.NRORG = DISTRIBUICAO.NRORG
                    INNER JOIN FILIAL                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              F ON F.CDFILIAL = DISTRIBUICAO.CDFILIAL
                                           AND F.NRORG = DISTRIBUICAO.NRORG
                    INNER JOIN SERVICO                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             S ON S.CDFILIAL = DISTRIBUICAO.CDFILIAL
                                            AND S.CDSERVFILI = DISTRIBUICAO.CDSERVFILI
                                                AND S.NRORG = DISTRIBUICAO.NRORG
                    INNER JOIN FILIAL                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              FC ON FC.CDFILIAL = DISTRIBUICAO.CDCENTRAL
                                            AND FC.NRORG = DISTRIBUICAO.NRORG
                ORDER BY
                    DISTRIBUICAO.NRDISTPROD,
                    PT.CDARVPROD,
                    DISTRIBUICAO.CDFILIAL,
                    DISTRIBUICAO.CDSERVFILI,
                    DISTRIBUICAO.DTCARDAPIO";
                    
	    $params = array (
	        "P_NRORG"        => $row["NRORG"],
	        "P_CDCENTRAL"    => $row["CDCENTRAL"],
	        "P_DTCONSUMOINI" => $row["DTINICIAL"],
	        "P_NRLISTASERV"  => $row["NRLISTASERV"],
	        "P_DTCONSUMOFIN" => $row["DTFINAL"],
	        "P_NRDISTPROD"   => $row["NRDISTPROD"],
	        "P_LISTAPROD"    => $row["LISTAPRODUTO"]
	   );
	   
	    $data = $this->entityManager->getConnection()->fetchAll($sql, $params);
        $response->addDataset(new DataSet('relCustomizavel', array($data)));
	}

}